/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : List.hi                                                  */
/*                                                                       */
/*       Date : May , 1997                                               */
/* Updated at : November 14, 1997                                        */
/*                                                                       */
/*     Author : H. Timucin OZDEMIR                                       */
/*                                                                       */
/*************************************************************************/
/*************************************************************************/

#ifndef _LIST_H
#define _LIST_H

#include <iostream.h>
#include "ListNode.h"

template<class T1>
class List
{  public :

     List();
     List(const List<T1>&);
     ~List();

     void addElement(T1);
     void removeElement(T1);

     T1 getElement(int);

     List<T1> operator=(const List<T1>&);

     operator==(const List<T1>&);

     void printMe(ostream&) const;

     unsigned getSize() const;

     friend ostream & operator<<(ostream& os,const List<T1>& RHS)
     {
	RHS.printMe(os);
	return os;
     };

   private:

     ListNode<T1>*  head;
          unsigned  size;

     void dispose();
     void copyFrom(const List<T1>&);

}; // end of class List

#endif
